(* Delphi Dialog
   Formateinstellungen fr CSV-Daten-Export
   ========================================
   
    J. Rathlev, IEAP, Uni-Kiel, (rathlev(a)physik.uni-kiel.de)

   The contents of this file may be used under the terms of the
   Mozilla Public License ("MPL") or
   GNU Lesser General Public License Version 2 or later (the "LGPL")

   Software distributed under this License is distributed on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
   the specific language governing rights and limitations under the License.
   
   Vers. 1 - Mai 2005 
   *)
   
unit ExportDlg;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, JrUtils, Spin;

type
  TExportDialog = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    DelimGroup: TRadioGroup;
    DelChar: TEdit;
    SpaltGroup: TRadioGroup;
    ColWidthEdit: TSpinEdit;
    Panel1: TPanel;
    EncloseCB: TCheckBox;
    procedure DelimGroupClick(Sender: TObject);
    procedure SpaltGroupClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    NDel : char;
  public
    { Public declarations }
    (* Dialog anzeigen *)
    function Execute (Titel : string;
                      var Delim     : char;
                      var ColWidth  : integer;
                      var Fill,Enclose : boolean) : boolean;
  end;

var
  ExportDialog: TExportDialog;

implementation

{$R *.DFM}

uses gnugettext;

{ ------------------------------------------------------------------- }
procedure TExportDialog.FormCreate(Sender: TObject);
begin
  TranslateComponent (self,'dialogs');
  end;

procedure TExportDialog.DelimGroupClick(Sender: TObject);
begin
  with DelimGroup do if ItemIndex=2 then begin
    DelChar.Show;
    end
  else begin
    case ItemIndex of
      0 : NDel:=Space;
      1 : NDel:=Semikolon;
      3 : NDel:=Komma;
      4 : NDel:=Tab;
        end;
    DelChar.Hide;
    end;
  end;

procedure TExportDialog.SpaltGroupClick(Sender: TObject);
begin
  ColWidthEdit.Visible:=SpaltGroup.ItemIndex=0;
  end;

{ ------------------------------------------------------------------- }
(* Dialog anzeigen *)
function TExportDialog.Execute (Titel : string;
                                var Delim     : char;
                                var ColWidth  : integer;
                                var Fill,Enclose : boolean) : boolean;
var
  ok : boolean;
begin
  if length(Titel)>0 then Caption:=Titel;
  NDel:=Delim; DelChar.Text:='';
  with DelimGroup do begin
    DelChar.Hide;
    case NDel of
    Space     : ItemIndex:=0;
    Semikolon : ItemIndex:=1;
    Komma     : ItemIndex:=3;
    Tab       : ItemIndex:=4;
      else with DelChar do begin
        ItemIndex:=2;
        Text:=NDel; Show;
        end;
      end;
    end;
  with SpaltGroup do if Fill then ItemIndex:=0 else ItemIndex:=1;
  EncloseCB.Checked:=Enclose;
  with ColWidthEdit do begin
    Value:=ColWidth; Visible:=Fill;
    end;
  ok:=ShowModal=mrOK;
  if ok then begin
    if DelimGroup.ItemIndex=2 then NDel:=DelChar.Text[1];
    Delim:=NDel;
    Fill:=SpaltGroup.ItemIndex=0;
    if Fill then ColWidth:=ColWidthEdit.Value;
    Enclose:=EncloseCB.Checked;
    Result:=true;
    end
  else Result:=false;
  end;

end.
