(* Dialog for FTP proxy connection parameters

    J. Rathlev, IEAP, Uni-Kiel, (rathlev(a)physik.uni-kiel.de)

   The contents of this file may be used under the terms of the
   GNU Lesser General Public License Version 2 or later (the "LGPL")

   Software distributed under this License is distributed on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
   the specific language governing rights and limitations under the License.

   Vers. 1 - Jul. 2007
   *)

unit FtpProxyDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, NumberEd, FtpFileTools;

type
  TFtpProxyDialog = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edProxy: TEdit;
    edUser: TEdit;
    edProxyPwd: TEdit;
    Label5: TLabel;
    edtPort: TRangeEdit;
    rgMethod: TRadioGroup;
    btnShow: TSpeedButton;
    procedure btnShowClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function Execute (var AProxyPar : TFtpProxyParams; ShowPwd : boolean) : boolean;
  end;

var
  FtpProxyDialog: TFtpProxyDialog;

implementation

{$R *.dfm}

uses IdFtp, GnuGetText;

procedure TFtpProxyDialog.FormCreate(Sender: TObject);
begin
  TranslateComponent (self,'dialogs');
  end;

procedure TFtpProxyDialog.btnShowClick(Sender: TObject);
var
  c : char;
begin
  if btnShow.Down then c:=#0 else c:='*';
  edProxyPwd.PasswordChar:=c;
  end;

function TFtpProxyDialog.Execute (var AProxyPar : TFtpProxyParams; ShowPwd : boolean) : boolean;
begin
  btnShow.Visible:=ShowPwd;
  with AProxyPar do begin
    edProxy.Text:=Server;
    edtPort.Value:=Port;
    edUser.Text:=Username;
    edProxyPwd.Text:=Password;
    with rgMethod do if Mode=fpcmNone then ItemIndex:=0
    else ItemIndex:=integer(Mode)-1;
    ActiveControl:=edProxy;
    if ShowModal=mrOK then begin
      Server:=edProxy.Text;
      Port:=edtPort.Value;
      Username:=edUser.Text;
      Password:=edProxyPwd.Text;
      Mode:=TIdFtpProxyType(rgMethod.ItemIndex+1);
      Result:=true;
      end
    else Result:=false;
    end;
  end;

end.
