(*  Delphi Dialog
    Select date
    ==============

    J. Rathlev, IEAP, Uni-Kiel, (rathlev(a)physik.uni-kiel.de)

   The contents of this file may be used under the terms of the
   Mozilla Public License ("MPL") or
   GNU Lesser General Public License Version 2 or later (the "LGPL")

   Software distributed under this License is distributed on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
   the specific language governing rights and limitations under the License.
    
   Okt. 2002/2010
   *)
   
unit Kalender;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Grids, Calendar, ExtCtrls, NumberEd, ComCtrls;

type
  TKalenderDialog = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    CalendarBox: TCalendar;
    MonatZur: TSpeedButton;
    Januar: TSpeedButton;
    QuartalZur: TSpeedButton;
    MonatWahl: TComboBox;
    MonatVor: TSpeedButton;
    QuartalVor: TSpeedButton;
    Dezember: TSpeedButton;
    JahrZur: TSpeedButton;
    JahrVor: TSpeedButton;
    JahrWahl: TNumberEdit;
    procedure ShowMonat;
    procedure MonatWahlChange(Sender: TObject);
    procedure QuartalZurClick(Sender: TObject);
    procedure QuartalVorClick(Sender: TObject);
    procedure MonatVorClick(Sender: TObject);
    procedure MonatZurClick(Sender: TObject);
    procedure JanuarClick(Sender: TObject);
    procedure DezemberClick(Sender: TObject);
    procedure JahrZurClick(Sender: TObject);
    procedure JahrVorClick(Sender: TObject);
    procedure JahrWahlChange(Sender: TObject);
    procedure CalendarBoxDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function Execute (ATitel : string;
                      var MTag,Monat,Jahr : word) : boolean;
  end;

var
  KalenderDialog: TKalenderDialog;

implementation

{$R *.DFM}

uses GnuGetText;

{------------------------------------------------------------------- }
procedure TKalenderDialog.FormCreate(Sender: TObject);
begin
  TranslateComponent (self,'dialogs');
  end;

procedure TKalenderDialog.ShowMonat;
begin
  with MonatWahl do begin
    ItemIndex:=pred(CalendarBox.Month);
    Text:=Items[ItemIndex];
    end;
  end;

procedure TKalenderDialog.MonatWahlChange(Sender: TObject);
begin
  CalendarBox.Month:=succ(MonatWahl.ItemIndex);
  end;

procedure TKalenderDialog.QuartalZurClick(Sender: TObject);
begin
  with CalendarBox do if Month>3 then Month:=Month-3 else Month:=1;
  ShowMonat;
  end;

procedure TKalenderDialog.QuartalVorClick(Sender: TObject);
begin
  with CalendarBox do if Month<10 then Month:=Month+3 else Month:=12;;
  ShowMonat;
  end;

procedure TKalenderDialog.MonatVorClick(Sender: TObject);
begin
  with CalendarBox do if Month<12 then Month:=Month+1;
  ShowMonat;
  end;

procedure TKalenderDialog.MonatZurClick(Sender: TObject);
begin
  with CalendarBox do if Month>1 then Month:=Month-1;
  ShowMonat;
  end;

procedure TKalenderDialog.JanuarClick(Sender: TObject);
begin
  CalendarBox.Month:=1;
  ShowMonat;
  end;

procedure TKalenderDialog.DezemberClick(Sender: TObject);
begin
  CalendarBox.Month:=12;
  ShowMonat;
  end;

procedure TKalenderDialog.JahrZurClick(Sender: TObject);
begin
  with CalendarBox do Year:=Year-1;
  JahrWahl.Value:=CalendarBox.Year;
  end;

procedure TKalenderDialog.JahrVorClick(Sender: TObject);
begin
  with CalendarBox do Year:=Year+1;
  JahrWahl.Value:=CalendarBox.Year;
  end;

procedure TKalenderDialog.JahrWahlChange(Sender: TObject);
begin
  try
    CalendarBox.Year:=JahrWahl.Value;
  except
    end;
end;

procedure TKalenderDialog.CalendarBoxDblClick(Sender: TObject);
begin
  ModalResult:=mrOK;
end;

{------------------------------------------------------------------- }
function TKalenderDialog.Execute (ATitel : string;
                               var MTag,Monat,Jahr : word) : boolean;
begin
  Caption:=ATitel;
  with CalendarBox do begin
    Day:=MTag;
    Month:=Monat;
    Year:=Jahr;
    end;
  ShowMonat;
  JahrWahl.Value:=CalendarBox.Year;
  if ShowModal=mrOK then begin
    with CalendarBox do begin
      MTag:=Day; Monat:=Month; Jahr:=Year;
      end;
    Result:=true;
    end
  else Result:=false;
  end;

end.
