(* Delphi Dialog
   Passwort-Abfrage
   ================
   Design hnlich wie Datei-Dialog unter Windows 2000/XP

    J. Rathlev, IEAP, Uni-Kiel, (rathlev(a)physik.uni-kiel.de)

   The contents of this file may be used under the terms of the
   Mozilla Public License ("MPL") or
   GNU Lesser General Public License Version 2 or later (the "LGPL")

   Software distributed under this License is distributed on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
   the specific language governing rights and limitations under the License.
    
   Vers. 1 - Dez. 2006
   *)

unit PwdDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls;

type
  TPasswordDialog = class(TForm)
    Label1: TLabel;
    edtPwd: TEdit;
    lblPrompt: TLabel;
    CancelBtn: TBitBtn;
    OKBtn: TBitBtn;
    btnSkip: TBitBtn;
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    function Execute (Title,Prompt : string; var Pwd : string;
                      Skip         : boolean) : TModalResult;
  end;

// Result:  Skip = mrYes, Ok = mrOK, Cancel = mrCancel
function ReadPassword (Title,Prompt : string; var Pwd : string;
                       Skip         : boolean) : TModalResult;

var
  PasswordDialog: TPasswordDialog;

implementation

{$R *.dfm}

uses GnuGetText;

{------------------------------------------------------------------- }
procedure TPasswordDialog.FormCreate(Sender: TObject);
begin
  TranslateComponent (self,'dialogs');
  end;

{ ------------------------------------------------------------------- }
(* Passworteingabe, Ergebnis: "true" bei "ok" *)
function TPasswordDialog.Execute (Title,Prompt : string;
                                  var Pwd      : string;
                                  Skip         : boolean) : TModalResult;
begin
  Caption:=Title;
  lblPrompt.Caption:=Prompt;
  edtPwd.Text:=Pwd;
  btnSkip.Visible:=Skip;
  ActiveControl:=edtPwd;
  Result:=ShowModal;
  if Result=mrOk then Pwd:=edtPwd.Text;
  end;

function ReadPassword (Title,Prompt : string; var Pwd : string;
                       Skip         : boolean) : TModalResult;
begin
  if not assigned(PasswordDialog) then PasswordDialog:=TPasswordDialog.Create(Application);
  with PasswordDialog do begin
    Result:=Execute(Title,Prompt,Pwd,Skip);
    Release;
    end;
  PasswordDialog:=nil;
  end;

end.
