(* Delphi Dialog
   Text anzeigen
   =============

    J. Rathlev, IEAP, Uni-Kiel, (rathlev(a)physik.uni-kiel.de)

   The contents of this file may be used under the terms of the
   Mozilla Public License ("MPL") or
   GNU Lesser General Public License Version 2 or later (the "LGPL")

   Software distributed under this License is distributed on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
   the specific language governing rights and limitations under the License.
    
   Vers. 1 - Mai 2005
         1.1 - Mrz. 2006  - uses Sleep instead of TWaitTimer
   *)

unit Show;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, JrUtils;

type
  TfrmShow = class(TForm)
    memShow: TMemo;
    panButtons: TPanel;
    Panel2: TPanel;
    btnOK: TBitBtn;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
//    wt        : TWaitTimer;
  public
    { Public declarations }
    procedure ShowWin (Delay : integer);
  end;

var
  frmShow: TfrmShow;

implementation

{$R *.DFM}

uses GnuGetText;

{------------------------------------------------------------------- }
procedure TfrmShow.FormCreate(Sender: TObject);
begin
  TranslateComponent (self,'dialogs');
  end;

{------------------------------------------------------------------- }
// Fenster mit Text (memShow) anzeigen
// Delay = 0 : Anzeige wartet auf Benutzer
//       > 0 : Anzeige fr "Delay" Sekunden
procedure TfrmShow.ShowWin (Delay : integer);
var
  i : integer;
begin
  if memShow.Lines.Count>0 then begin
    if Delay=0 then begin
      panButtons.Show;
      ShowModal;
      end
    else begin
//      wt:=TWaitTimer.Create;
      panButtons.Hide;
      Show; Update;
      for i:=1 to Delay*10 do begin
        Sleep(100);
        Application.ProcessMessages;
        end;
//      wt.Wait(Delay*1000);
//      wt.Free;
      Close;
      end;
    end;
  end;

end.
