unit ShowImage;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls;

type
  TShowImageDialog = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Image: TImage;
    btnOK: TBitBtn;
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FIniFileName,FIniSection  : string;
  public
    { Public declarations }
    procedure LoadFromIni(AIniName,AIniSection : string);
    procedure Execute (Titel,ImageName : string);
  end;

var
  ShowImageDialog: TShowImageDialog;

implementation

{$R *.DFM}

uses IniFiles;

const
  (* INI-Sektionen *)
  iniLeft   = 'Left';
  iniTop    = 'Top';
  iniHeight = 'Height';

procedure TShowImageDialog.FormCreate(Sender: TObject);
begin
  FIniFileName:=''; FIniSection:='';
  end;

procedure TShowImageDialog.FormDestroy(Sender: TObject);
var
  IniFile : TIniFile;
begin
  if (FIniFileName<>'') and (FIniSection<>'') then begin
    IniFile:=TIniFile.Create(FIniFileName);
    with IniFile do begin
      WriteInteger (FIniSection,iniTop,Top);
      WriteInteger (FIniSection,iniLeft,Left);
      WriteInteger (FIniSection,iniHeight,Height);
      Free;
      end;
    end;
  end;

procedure TShowImageDialog.LoadFromIni (AIniName,AIniSection : string);
var
  IniFile : TIniFile;
begin
  FIniFileName:=AIniName; FIniSection:=AIniSection;
  IniFile:=TIniFile.Create(FIniFileName);
  with IniFile do begin
    Top:=ReadInteger (FIniSection,iniTop,Top);
    Left:=ReadInteger (FIniSection,iniLeft,Left);
    Height:=ReadInteger (FIniSection,iniHeight,Height);
    Free;
    end;
  end;

procedure TShowImageDialog.FormResize(Sender: TObject);
var
  r : double;
begin
  with Image.Picture do if Height>0 then r:=Width/Height
  else r:=1;;
  ClientWidth:=round(Image.Height*r);
  end;

procedure TShowImageDialog.Execute (Titel,ImageName : string);
begin
  Caption:=Titel;
  Image.Picture.LoadFromFile(ImageName);
  ShowModal;
  end;

end.
