(* Delphi-Unit
   Texteingabefenster
   J. Rathlev, Dez. 1995 *)

unit TextDlg;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils, Dialogs, JrUtils;

type
  TSwitchMode = (tsNotVis,tsOff,tsOn);

  TTextEingabe = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Rahmen: TBevel;
    TextFeld1: TEdit;
    Descriptor1: TLabel;
    Switch: TCheckBox;
    Descriptor2: TLabel;
    Textfeld2: TEdit;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function Execute(Titel,Desc1,Desc2,SwDesc : string;
                     X,Y               : integer;
                     var AText,BText   : string;
                     var TSw           : TSwitchMode) : boolean;
  end;

(* Text bearbeiten, Ergebnis: "true" bei "ok" *)
function TextDialog (Titel,Desc : string;
                     X,Y        : integer;
                     var Text   : string) : boolean;

(* Pawort eingeben , Ergebnis: "true" bei "ok" *)
function PwdDialog (Titel,Desc : string;
                    X,Y        : integer;
                    var Pwd    : string) : boolean;

(* Doppeltext bearbeiten, Ergebnis: "true" bei "ok" *)
function DTextDialog (Titel,Desc1,Desc2 : string;
                      X,Y               : integer;
                      var Text1,Text2   : string) : boolean;

(* Zahl bearbeiten, Ergebnis: "true" bei "ok" *)
function NumberDialog (Titel,Desc : string;
                       X,Y        : integer;
                       var n      : longint) : boolean;

(* 2 Zahlen bearbeiten, Ergebnis: "true" bei "ok" *)
function DNumberDialog (Titel,Desc1,Desc2 : string;
                        X,Y               : integer;
                        var n1,n2         : longint) : boolean;

(* 2 Double-Zahlen bearbeiten, Ergebnis: "true" bei "ok" *)
function DFNumberDialog (Titel,Desc1,Desc2 : string;
                         X,Y               : integer;
                         var n1,n2         : double) : boolean;

(* Text bearbeiten, Schalter abfragen, Ergebnis: "true" bei "ok" *)
function TextSwDialog (Titel,Desc,SwDesc : string;
                       X,Y               : integer;
                       var Text          : string;
                       var TSw           : TSwitchMode) : boolean;

(* Text bearbeiten, Ergebnis: genderter Text bei "ok"
                              alter Text bei "Abbruch" *)
function EditText (Titel,Desc : string;
                   X,Y        : integer;
                   Text       : string) : string;

var
  TextEingabe: TTextEingabe;

implementation

{$R *.DFM}

uses GnuGetText;

procedure TTextEingabe.FormCreate(Sender: TObject);
begin
  TranslateComponent (self,'dialogs');
  end;

{ ------------------------------------------------------------------- }
(* Text-Dialog mit 1 oder 2 Feldern anzeigen *)
function TTextEingabe.Execute(Titel,Desc1,Desc2,SwDesc : string;
                              X,Y               : integer;
                              var AText,BText   : string;
                              var TSw           : TSwitchMode) : boolean;

var
  ok : boolean;
begin
  Caption:=Titel;
  with Switch do if TSw=tsNotVis then Visible:=false
  else begin
    Visible:=true; Checked:=Tsw=tsOn;
    Caption:=SwDesc;
    end;
  if X>=0 then begin
    CheckScreenBounds (Screen,X,Y,Width,Height);
    Left:=X; Top:=Y; Position:=poDesigned;
    end
  else Position:=poScreenCenter;
  if Desc2<>'' then begin
    TextFeld2.Visible:=true; Descriptor2.Visible:=true;
    Descriptor2.Caption:=Desc2;
    with TextFeld1 do begin
      Text:=AText; Width:=166; AutoSelect:=true;
      end;
    with TextFeld2 do begin
      Text:=BText; Width:=166; AutoSelect:=true;
      end;
    end
  else begin
    TextFeld2.Visible:=false; Descriptor2.Visible:=false;
    with TextFeld1 do begin
      Text:=AText; Width:=Rahmen.Width-20; AutoSelect:=true;
      end;
    end;
  Descriptor1.Caption:=Desc1;
  ActiveControl:=TextFeld1;
  ok:=ShowModal=mrOK;
  if ok then begin
    AText:=TextFeld1.Text;
    if Desc2<>'' then BText:=TextFeld2.Text;
    if TSw<>tsNotVis then with Switch do
      if Checked then TSw:=tsOn else TSw:=TsOff;
    end;
  Result:=ok;
  end;

{ ------------------------------------------------------------------- }
(* Text bearbeiten, Ergebnis: "true" bei "ok" *)
function TextDialog (Titel,Desc : string;
                     X,Y        : integer;
                     var Text   : string) : boolean;
var
  TSw : TSwitchMode;
  s   : string;
begin
  TSw:=tsNotVis; s:='';
  Result:=TextEingabe.Execute (Titel,Desc,'','',X,Y,Text,s,TSw);
  end;

{ ------------------------------------------------------------------- }
(* Pawort eingeben , Ergebnis: "true" bei "ok" *)
function PwdDialog (Titel,Desc : string;
                    X,Y        : integer;
                    var Pwd    : string) : boolean;
var
  TSw : TSwitchMode;
  s   : string;
begin
  with TextEingabe do begin
    TSw:=tsNotVis; s:='';
    TextFeld1.PasswordChar:='*';
    Pwd:='';
    Result:=Execute (Titel,Desc,'','',X,Y,Pwd,s,TSw);
    TextFeld1.PasswordChar:=#0;
    end;
  end;

{ ------------------------------------------------------------------- }
(* Doppeltext bearbeiten, Ergebnis: "true" bei "ok" *)
function DTextDialog (Titel,Desc1,Desc2 : string;
                      X,Y               : integer;
                      var Text1,Text2   : string) : boolean;
var
  TSw : TSwitchMode;
begin
  TSw:=tsNotVis;
  Result:=TextEingabe.Execute (Titel,Desc1,Desc2,'',X,Y,Text1,Text2,TSw);
  end;

{ ------------------------------------------------------------------- }
(* Integer-Zahl bearbeiten, Ergebnis: "true" bei "ok" *)
function NumberDialog (Titel,Desc : string;
                       X,Y        : integer;
                       var n      : longint) : boolean;
var
  TSw : TSwitchMode;
  s,t : string;
  nn  : longint;
  ende,
  ok  : boolean;
begin
  TSw:=tsNotVis; s:=IntToStr (n); nn:=0;
  repeat
    ok:=TextEingabe.Execute (Titel,Desc,'','',X,Y,s,t,TSw);
    ende:=true;
    if ok then begin
      try
        nn:=StrToInt(s);
      except
        on EConvertError do begin
          ende:=MessageDialog(Titel,dgettext('dialogs','Invalid input'),mtError,mbOKCancel)=mrCancel;
          ok:=false;
          end;
        end;
      end;
    until ende;
  if ok then n:=nn;
  Result:=ok;
  end;

{ ------------------------------------------------------------------- }
(* 2 Integer-Zahlen bearbeiten, Ergebnis: "true" bei "ok" *)
function DNumberDialog (Titel,Desc1,Desc2 : string;
                        X,Y               : integer;
                        var n1,n2         : longint) : boolean;
var
  TSw : TSwitchMode;
  s,t : string;
  nn  : longint;
  ende,
  ok  : boolean;
begin
  TSw:=tsNotVis; s:=IntToStr (n1); t:=IntToStr (n2); nn:=0;
  repeat
    ok:=TextEingabe.Execute (Titel,Desc1,Desc2,'',X,Y,s,t,TSw);
    ende:=true;
    if ok then begin
      try
        nn:=StrToInt(s);
      except
        on EConvertError do begin
          ende:=MessageDialog(Titel,dgettext('dialogs','Invalid input'),mtError,mbOKCancel)=mrCancel;
          ok:=false;
          end;
        end;
      if ok then begin
        n1:=nn;
        try
          nn:=StrToInt(t);
        except
          on EConvertError do begin
            ende:=MessageDialog(Titel,dgettext('dialogs','Invalid input'),mtError,mbOKCancel)=mrCancel;
            ok:=false;
            end;
          end;
        if ok then n2:=nn;
        end;
      end;
    until ende;
  Result:=ok;
  end;

{ ------------------------------------------------------------------- }
(* 2 Double-Zahlen bearbeiten, Ergebnis: "true" bei "ok" *)
function DFNumberDialog (Titel,Desc1,Desc2 : string;
                         X,Y               : integer;
                         var n1,n2         : double) : boolean;
var
  TSw : TSwitchMode;
  s,t : string;
  nn  : double;
  ende,
  ok  : boolean;
begin
  TSw:=tsNotVis; s:=StrDbl (n1,0,0); t:=StrDbl (n2,0,0); nn:=0;
  repeat
    ok:=TextEingabe.Execute (Titel,Desc1,Desc2,'',X,Y,s,t,TSw);
    ende:=true;
    if ok then begin
      try
        nn:=StrToInt(ReplDecPt(s));
      except
        on EConvertError do begin
          ende:=MessageDialog(Titel,dgettext('dialogs','Invalid input'),mtError,mbOKCancel)=mrCancel;
          ok:=false;
          end;
        end;
      if ok then begin
        n1:=nn;
        try
          nn:=StrToInt(ReplDecPt(t));
        except
          on EConvertError do begin
            ende:=MessageDialog(Titel,dgettext('dialogs','Invalid input'),mtError,mbOKCancel)=mrCancel;
            ok:=false;
            end;
          end;
        if ok then n2:=nn;
        end;
      end;
    until ende;
  Result:=ok;
  end;

{ ------------------------------------------------------------------- }
(* Text bearbeiten, Schalter abfragen, Ergebnis: "true" bei "ok" *)
function TextSwDialog (Titel,Desc,SwDesc : string;
                       X,Y               : integer;
                       var Text          : string;
                       var TSw           : TSwitchMode) : boolean;
var
  s   : string;
begin
  s:='';
  Result:=TextEingabe.Execute (Titel,Desc,'',SwDesc,X,Y,Text,s,TSw);
  end;

{ ------------------------------------------------------------------- }
(* Text bearbeiten, Ergebnis: genderter Text bei "ok"
                              alter Text bei "Abbruch" *)
function EditText (Titel,Desc : string;
                   X,Y        : integer;
                   Text       : string) : string;
var
  s,t : string;
  TSw : TSwitchMode;
begin
  s:=Text; t:=''; TSw:=tsNotVis;
  if TextEingabe.Execute (Titel,Desc,'','',X,Y,s,t,TSw) then Result:=s
  else Result:=Text;
  end;

end.
